//**************************************************************************
//*                     This file is part of the                           *
//*                      Mpxplay - audio player.                           *
//*                  The source code of Mpxplay is                         *
//*        (C) copyright 1998-2005 by PDSoft (Attila Padar)                *
//*                    http://mpxplay.cjb.net                              *
//*                  email: mpxplay@freemail.hu                            *
//**************************************************************************
//*  This program is distributed in the hope that it will be useful,       *
//*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
//*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
//*  Please contact with the author (with me) if you want to use           *
//*  or modify this source.                                                *
//**************************************************************************
//function: PCM (WAV) "decoding"

#include "in_file.h"
#include "newfunc\newfunc.h"

static int AD_PCM_open(struct mpxplay_audio_decoder_info_s *adi,struct mpxplay_streampacket_info_s *spi)
{
 if(adi->wave_id==MPXPLAY_WAVEID_WAVFLOAT){
  funcbit_enable(adi->infobits,ADI_FLAG_FLOATOUT);
  adi->bitratetext="32-float";
 }

 if(!adi->bytespersample)
  return MPXPLAY_ERROR_INFILE_CANTOPEN;

 adi->pcm_framelen=spi->bs_framesize/adi->bytespersample/adi->outchannels;

 funcbit_disable(spi->flags,MPXPLAY_SPI_FLAG_NEED_PARSING); // !!!

 return MPXPLAY_ERROR_INFILE_OK;
}

static int AD_PCM_decode(struct mpxplay_audio_decoder_info_s *adi,struct mpxplay_streampacket_info_s *spi)
{
 if(spi->bs_leftbytes){
  pds_memcpy(adi->pcm_bufptr,spi->bitstreambuf,spi->bs_leftbytes);
  spi->bs_usedbytes=spi->bs_leftbytes;
  adi->pcm_samplenum=spi->bs_leftbytes/adi->bytespersample;
 }

 return MPXPLAY_ERROR_INFILE_OK;
}

struct mpxplay_audio_decoder_func_s AD_PCM_funcs={
 0,
 NULL,
 NULL,
 &AD_PCM_open,
 NULL,
 NULL,
 NULL,
 &AD_PCM_decode,
 NULL,
 NULL,
 NULL,
 0,
 0,
 {{MPXPLAY_WAVEID_WAV_SLE,"PCM"},{MPXPLAY_WAVEID_WAVFLOAT,"PCM"},{0,NULL}}
};
